%global eclipse_dropins %{_datadir}/eclipse/dropins
%global build_base      jbosstools-build-sites/aggregate/local-site/.m2/org/jboss/tools/
%global rls_tag         Final

Name:           eclipse-jbosstools
Version:        4.1.1
Release:        2%{?dist}
Summary:        Eclipse plugins that support JBoss and related technology

# For mult. license info, see https://community.jboss.org/thread/158037
License:        EPL and LGPLv2+ and ASL 2.0
URL:            http://www.jboss.org/tools.html

# Steps to create this are found in create-tarball.sh
Source0:        %{name}-%{version}.%{rls_tag}.tar.xz

Source1:        LICENSE-2.0.txt
Source2:        lgpl-2.1.txt
Source3:        create-tarball.sh

# feature.xml patch to remove 'requires' section - fails because of the way we
# have wtp packages set up currently - not all have same qualifier.
Patch10:        %{name}-ws-rm-requires.patch

# fix classpath entry to unversioned freemarker.jar (symlinked from _javadir)
Patch12:        %{name}-freemarker-4.0.0.patch

# Update refs from old bundled deps in archives, to symlinked deps from Fedora
Patch14:        %{name}-archives-core-manifest-4.0.0.patch
Patch15:        %{name}-archives-core-buildproperties-4.0.0.patch

# Migrate to from obselete to current version of TrueZip dependency
Patch16:        %{name}-archives-core-trueziputil-4.0.0.patch
Patch17:        %{name}-archives-core-modeltruezipbridge.patch
Patch18:        %{name}-archives-core-archivesbuilder.patch
Patch19:        %{name}-as-archives.webtools-4.0.0.patch

# Update refs from old bundled deps in AS, to symlinked deps from Fedora
Patch21:        %{name}-as.dmr-4.0.0.patch
Patch22:        %{name}-as.core.patch
Patch23:        %{name}-as.mgmt.as71-4.0.0.patch

# Update refs from bundled deps in Openshift, to symlinked deps from Fedora
Patch24:        %{name}-openshift-bundledjarnames.patch

# Use unversioned deps in org.jboss.tools.ws.wise.ui
Patch25:        %{name}-ws.wise.ui-deps.patch

BuildArch:      noarch

BuildRequires:  ant >= 1.8.4
BuildRequires:  ant-contrib >= 1.0
BuildRequires:  apache-commons-codec >= 1.6
BuildRequires:  axis >= 1.4-16
BuildRequires:  dom4j >= 1.6.1-8
BuildRequires:  eclipse-dtp >= 1.10
BuildRequires:  eclipse-egit >= 3.0.0
BuildRequires:  eclipse-emf-core >= 2.8.1
BuildRequires:  eclipse-gef >= 3.8.0
BuildRequires:  eclipse-jdt >= 4.3.0
BuildRequires:  eclipse-m2e-core >= 1.4.0
BuildRequires:  eclipse-mylyn >= 3.9.0
BuildRequires:  eclipse-pde >= 4.3.0
BuildRequires:  eclipse-platform >= 4.3.0
BuildRequires:  eclipse-rse >= 3.4
BuildRequires:  eclipse-swt >= 4.3.0
BuildRequires:  eclipse-wtp-common >= 3.5.0
BuildRequires:  eclipse-wtp-jeetools >= 3.5.0
BuildRequires:  eclipse-wtp-jpa >= 3.5.0
BuildRequires:  eclipse-wtp-jsf >= 3.5.0
BuildRequires:  eclipse-wtp-jst-web >= 3.5.0
BuildRequires:  eclipse-wtp-servertools >= 3.5.0
BuildRequires:  eclipse-wtp-webservices >= 3.5.0-4
BuildRequires:  eclipse-wtp-sourceediting >= 3.5.0
BuildRequires:  gnu-getopt >= 1.0.13
BuildRequires:  icu4j-eclipse >= 4.4.2.2
BuildRequires:  jacoco-maven-plugin
BuildRequires:  jakarta-commons-httpclient >= 3.1
BuildRequires:  java-devel
BuildRequires:  jaxen >= 1.1.3
BuildRequires:  wildfly
BuildRequires:  jboss-dmr >= 1.1.1
BuildRequires:  jpackage-utils
BuildRequires:  maven-local
BuildRequires:  maven-jar-plugin
BuildRequires:  maven-install-plugin
BuildRequires:  maven-javadoc-plugin
BuildRequires:  maven-release-plugin
BuildRequires:  maven-compiler-plugin
BuildRequires:  maven-surefire-plugin
BuildRequires:  maven-resources-plugin
BuildRequires:  objectweb-asm
BuildRequires:  openshift-java-client >= 2.5.0
BuildRequires:  resteasy >= 2.3.2-7
BuildRequires:  truezip-driver-zip >= 7.6.6
BuildRequires:  truezip-file >= 7.6.6
BuildRequires:  tycho
BuildRequires:  tycho-extras
BuildRequires:  velocity >= 1.7-4
BuildRequires:  xerces-j2 >= 2.11.0-11
BuildRequires:  xpp3-minimal
BuildRequires:  mvn(org.jboss.jdf:stacks-client)
BuildRequires:  mvn(org.jboss.wise:wise-core)
BuildRequires:  mvn(org.jboss.wise:wise-core-cxf)
BuildRequires:  mvn(org.jboss.ws:jbossws-parent)

Requires:       java
Requires:       jpackage-utils

Requires:       %{name}-archives = %{version}-%{release}
Requires:       %{name}-as = %{version}-%{release}
Requires:       %{name}-cdi = %{version}-%{release}
Requires:       %{name}-common = %{version}-%{release}
Requires:       %{name}-freemarker = %{version}-%{release}
Requires:       %{name}-jmx = %{version}-%{release}
Requires:       %{name}-jst = %{version}-%{release}
Requires:       %{name}-openshift = %{version}-%{release}
Requires:       %{name}-parent = %{version}-%{release}
Requires:       %{name}-runtime = %{version}-%{release}
Requires:       %{name}-usage = %{version}-%{release}
Requires:       %{name}-ws = %{version}-%{release}

%description
JBoss Tools is an umbrella project for a set of Eclipse plugins that supports
JBoss and related technology; there is support for Hibernate, JBoss AS, Drools, 
jBPM, JSF, (X)HTML, Seam, Maven, JBoss ESB, JBoss Portal and more...

%package        parent
Summary:        JBoss Tools Parent
Requires:       jpackage-utils

%description parent
Parent and target-platform POM files for %{name} package.

%package        common
Summary:        JBoss Tools common Eclipse tools

Requires:       %{name}-parent = %{version}-%{release}
Requires:       eclipse-gef
Requires:       eclipse-jdt
Requires:       eclipse-platform
Requires:       eclipse-pde
Requires:       eclipse-swt
Requires:       eclipse-wtp-common
Requires:       eclipse-wtp-jeetools
Requires:       eclipse-wtp-jpa
Requires:       eclipse-wtp-sourceediting
Requires:       jakarta-commons-httpclient
Requires:       java
Requires:       jpackage-utils
Requires:       xerces-j2

%description common
Common functionality on which other plugins and features from
%{name} depend.

%package        jmx
Summary:        Eclipse tools for interacting with JMX connections

Requires:       %{name}-parent = %{version}-%{release}
Requires:       eclipse-platform
Requires:       eclipse-swt
Requires:       java
Requires:       jpackage-utils

%description jmx
JBoss JMX Tools allows you to setup multiple JMX connections, and provides a
view for exploring the JMX tree and execute operations directly from within
Eclipse.

%package        archives
Summary:        JBoss Archives Tools

Requires:       %{name}-as = %{version}-%{release}
Requires:       %{name}-jmx = %{version}-%{release}
Requires:       %{name}-parent = %{version}-%{release}
Requires:       %{name}-usage = %{version}-%{release}
Requires:       ant
Requires:       eclipse-emf-core
Requires:       eclipse-jdt
Requires:       eclipse-pde
Requires:       eclipse-platform
Requires:       eclipse-swt
Requires:       eclipse-wtp-common
Requires:       eclipse-wtp-servertools
Requires:       java
Requires:       jpackage-utils
Requires:       truezip-driver-file
Requires:       truezip-file

%description archives
Project Archives provides a way to define archives based on include/exclude
filesets which then gets incrementally updated allowing for fluent
deployment for any type of Eclipse project.

%package        usage
Summary:        JBoss Tools Usage Reporting

Requires:       %{name}-parent = %{version}-%{release}
Requires:       eclipse-platform
Requires:       eclipse-swt
Requires:       java
Requires:       jpackage-utils

%description usage
JBoss Tools Usage reporting provides an anonymous opt-in call-back mechanism
that can be used to see how widely used plugins are, which plugin installations
have been done, where in the world and what versions of operating system, java
and other information that is available.

%package        as
Summary:        JBossAS Tools

Requires:       %{name}-archives = %{version}-%{release}
Requires:       %{name}-common = %{version}-%{release}
Requires:       %{name}-jmx = %{version}-%{release}
Requires:       %{name}-parent = %{version}-%{release}
Requires:       %{name}-usage = %{version}-%{release}
Requires:       ant
Requires:       dom4j
Requires:       eclipse-emf-core
Requires:       eclipse-jdt
Requires:       eclipse-pde
Requires:       eclipse-platform
Requires:       eclipse-rse
Requires:       eclipse-swt
Requires:       eclipse-wtp-common
Requires:       eclipse-wtp-jeetools
Requires:       eclipse-wtp-servertools
Requires:       gnu-getopt
Requires:       icu4j-eclipse
Requires:       java
Requires:       jaxen
Requires:       wildfly
Requires:       jboss-dmr
Requires:       jpackage-utils

%description as
Provides WTP server adapters for JBoss installations. These adapters are 
capable of deployment and providing classpaths for projects. Zipped or
exploded deployments, JMX integration, and other extensions are included.

%package        jst
Summary:        JBoss Tools Java Standard Tools

Requires:       %{name}-common = %{version}-%{release}
Requires:       %{name}-parent = %{version}-%{release}
Requires:       %{name}-usage = %{version}-%{release}
Requires:       ant
Requires:       eclipse-dtp
Requires:       eclipse-gef
Requires:       eclipse-jdt
Requires:       eclipse-mylyn
Requires:       eclipse-platform
Requires:       eclipse-swt
Requires:       eclipse-wtp-jeetools
Requires:       eclipse-wtp-jst-web
Requires:       eclipse-wtp-sourceediting
Requires:       java
Requires:       jpackage-utils
Requires:       velocity
Requires:       xerces-j2

%description jst
JBoss Tools Java Standard Tools provides common tools for use in JBoss Tools
other plugins, such as Knowledge Base builder and validators for use in JSF/Web
projects.

%package        ws
Summary:        JBoss WebServices Tools and JBoss JAX-RS Tools

Requires:       %{name}-as = %{version}-%{release}
Requires:       %{name}-common = %{version}-%{release}
Requires:       %{name}-parent = %{version}-%{release}
Requires:       %{name}-usage = %{version}-%{release}
Requires:       apache-commons-codec
Requires:       axis
Requires:       eclipse-emf-core
Requires:       eclipse-emf-xsd
Requires:       eclipse-jdt
Requires:       eclipse-platform
Requires:       eclipse-swt
Requires:       eclipse-wtp-common
Requires:       eclipse-wtp-jeetools
Requires:       eclipse-wtp-jsf
Requires:       eclipse-wtp-webservices >= 3.5.0-4
Requires:       icu4j-eclipse
Requires:       java
Requires:       jdom
Requires:       jpackage-utils
Requires:       resteasy
Requires:       wsdl4j


%description ws
JBoss WebServices Tools provides wizards for working with webservices
and a webservice tester view to test out both SOAP and REST services.

JBoss JAX-RS Tools provides a common navigator to browse and introspect
your JAX-RS endpoints and provide validation for JAX-RS annotations, such
as checking that parameters referenced by name actually also are declared.

%package        cdi
Summary:        JBoss CDI Tools, Apache Deltasipke Tools, Seam 3 Tools

Requires:       %{name}-common = %{version}-%{release}
Requires:       %{name}-jst = %{version}-%{release}
Requires:       %{name}-parent = %{version}-%{release}
Requires:       %{name}-usage = %{version}-%{release}
Requires:       ant
Requires:       eclipse-gef
Requires:       eclipse-jdt
Requires:       eclipse-platform
Requires:       eclipse-swt
Requires:       eclipse-wtp-common
Requires:       eclipse-wtp-jeetools
Requires:       eclipse-wtp-jsf
Requires:       eclipse-wtp-sourceediting
Requires:       java
Requires:       jpackage-utils
Requires:       xerces-j2

%description cdi
Context and Dependency Injection Tools provides support for JSR-299 also know
as CDI. Adds wizards, code navigation, validation and quickfixes to work with
projects that uses CDI.

Apache Deltasipke Tools provides tooling for the CDI components released as
part of Deltaspike modules.

Seam 3 Tools provides tooling for the CDI components released as part of
Seam 3 modules such as Solder and Config. Tooling covers recognizing
these CDI components and editing the seam config xml.

%package        freemarker
Summary:        FreeMarker IDE

Requires:       %{name}-parent = %{version}-%{release}
Requires:       %{name}-usage = %{version}-%{release}
Requires:       eclipse-jdt
Requires:       eclipse-platform
Requires:       eclipse-swt
Requires:       freemarker
Requires:       java
Requires:       jpackage-utils

%description freemarker
FreeMarkerIDE provides editor for FreeMarker templates

%package        runtime
Summary:        JBoss Runtime Detection

Requires:       %{name}-as = %{version}-%{release}
Requires:       eclipse-dtp
Requires:       eclipse-platform
Requires:       eclipse-swt
Requires:       eclipse-wtp-common
Requires:       java
Requires:       jpackage-utils

%description runtime
JBoss Runtime Detection

%package openshift
Summary:        JBoss Openshift Tools for Eclipse

Requires:       %{name}-as = %{version}-%{release}
Requires:       eclipse-egit
Requires:       eclipse-m2e-core
Requires:       eclipse-jdt
Requires:       eclipse-m2e-core
Requires:       eclipse-platform
Requires:       eclipse-swt
Requires:       eclipse-wtp-common
Requires:       openshift-java-client

%description openshift
OpenShift Tools provides wizards and views for
creating and maintaining OpenShift applications.

%package        base
Summary:        JBoss Base Tools

%description base
POM for %{summary}.

%package        foundation
Summary:        JBoss Tools Foundation

%description foundation
%{summary} provides utility classes and infrastructure for all other
plugins.

%package        stacks
Summary:        JBoss Stacks Tools

%description stacks
JBoss Stacks consumer which helps provide models for use by other
plugins.

%package        javaee
Summary:        JBoss JavaEE Tools

%description javaee
JavaEE Tools provides Eclipse plugins for features related to development
on JavaEE. This includes CDI, Seam, JSF and Struts.

%package        server
Summary:        JBoss Server Tools

%description server
Server Tools provide the JBoss Server Adapter for Eclipse WTP, project
archive tooling and JMX views.

%prep
%setup -q -n %{name}-%{version}.%{rls_tag}

cp %{SOURCE1} %{SOURCE2} .

find -name '*.jar' -delete
find -name '*.class' -delete

# add symlinks to Fedora versions of removed jars
pushd jbosstools-server/archives/plugins/org.jboss.ide.eclipse.archives.core/lib/
ln -s %{_javadir}/truezip/truezip-driver-file.jar
ln -s %{_javadir}/truezip/truezip-driver-zip.jar
ln -s %{_javadir}/truezip/truezip-file.jar
ln -s %{_javadir}/truezip/truezip-kernel.jar
popd
pushd jbosstools-server/as/plugins/org.jboss.ide.eclipse.as.dmr/
ln -s %{_javadir}/jboss-dmr/jboss-dmr.jar
popd
pushd jbosstools-server/as/plugins/org.jboss.ide.eclipse.as.core/
ln -s %{_javadir}/dom4j.jar
ln -s %{_javadir}/jaxen.jar
ln -s %{_javadir}/gnu-getopt.jar
popd
pushd jbosstools-server/as/plugins/org.jboss.ide.eclipse.as.management.as71/
ln -s %{_javadir}/wildfly/wildfly-controller-client.jar
ln -s %{_javadir}/wildfly/wildfly-protocol.jar
ln -s %{_javadir}/jboss-dmr/jboss-dmr.jar
ln -s %{_javadir}/jboss-logging/jboss-logging.jar
ln -s %{_javadir}/jboss-marshalling.jar
ln -s %{_javadir}/jboss-marshalling-river.jar
ln -s %{_javadir}/jboss-remoting/jboss-remoting.jar
ln -s %{_javadir}/jboss-sasl.jar
ln -s %{_javadir}/jboss-threads/jboss-threads.jar
ln -s %{_javadir}/xnio/xnio-api.jar
ln -s %{_javadir}/xnio/xnio-nio.jar
popd
pushd jbosstools-webservices/plugins/org.jboss.tools.ws.ui/lib/
ln -s %{_javadir}/axis/axis.jar
ln -s %{_javadir}/axis/jaxrpc.jar
ln -s %{_javadir}/resteasy/jaxrs-api.jar
popd
pushd jbosstools-freemarker/plugins/org.jboss.ide.eclipse.freemarker/
ln -s %{_javadir}/freemarker.jar
popd
pushd jbosstools-openshift/plugins/org.jboss.tools.openshift.express.client/
mkdir lib && pushd lib/
ln -s %{_javadir}/jboss-dmr/jboss-dmr.jar
ln -s %{_javadir}/log4j.jar
ln -s %{_javadir}/openshift-java-client/openshift-java-client.jar
ln -s %{_javadir}/slf4j/api.jar slf4j-api.jar
ln -s %{_javadir}/slf4j/log4j12.jar slf4j-log4j12.jar
popd
popd

# Remove custom repository-utils plugin from parent pom
%pom_remove_plugin org.jboss.tools.tycho-plugins:repository-utils jbosstools-build/parent

# Remove jacoco plugin -- broken in rawhide
%pom_remove_plugin org.jacoco:jacoco-maven-plugin jbosstools-build/parent

# Disable modules that fail to build
## build-site/aggregate/local-site
%pom_disable_module ../../../jbosstools-gwt jbosstools-build-sites/aggregate/local-site
%pom_disable_module ../../../jbosstools-forge jbosstools-build-sites/aggregate/local-site
%pom_disable_module ../../../jbosstools-hibernate jbosstools-build-sites/aggregate/local-site
%pom_disable_module ../../../jbosstools-birt jbosstools-build-sites/aggregate/local-site
%pom_disable_module ../../../jbosstools-xulrunner jbosstools-build-sites/aggregate/local-site
%pom_disable_module ../../../jbosstools-portlet jbosstools-build-sites/aggregate/local-site
%pom_disable_module ../../../jbosstools-central jbosstools-build-sites/aggregate/local-site
%pom_disable_module ../../../jbosstools-vpe jbosstools-build-sites/aggregate/local-site

## tests
disable_tests_module="base base/common base/runtime base/usage base/stacks base/foundation \
               server/archives server/jmx server/as server/wtp \
               jst webservices javaee/cdi freemarker openshift"
for pom in ${disable_tests_module}; do %pom_disable_module tests jbosstools-${pom}; done
## site
disable_site_module="base server jst webservices javaee freemarker openshift"
for pom in ${disable_site_module}; do %pom_disable_module site jbosstools-${pom}; done
## base
%pom_disable_module org.jboss.tools.common.mylyn jbosstools-base/common/plugins
%pom_disable_module org.jboss.tools.common.mylyn.test jbosstools-base/common/tests
%pom_disable_module org.jboss.tools.common.mylyn.feature jbosstools-base/common/features
%pom_disable_module org.jboss.tools.common.all.test.feature jbosstools-base/common/features
%pom_disable_module org.jboss.tools.usage.test.feature jbosstools-base/usage/features
%pom_disable_module org.jboss.tools.runtime.test.feature jbosstools-base/runtime/features
%pom_disable_module org.jboss.tools.stacks.core.test.feature jbosstools-base/stacks/features
%pom_disable_module org.jboss.tools.foundation.test.feature jbosstools-base/foundation/features
## server
%pom_disable_module org.jboss.ide.eclipse.archives.test.feature jbosstools-server/archives/features
%pom_disable_module org.jboss.tools.jmx.test.feature jbosstools-server/jmx/features
%pom_disable_module org.jboss.ide.eclipse.as.test.feature jbosstools-server/as/features
%pom_disable_module org.jboss.tools.wtp.runtimes.tomcat.tests.feature jbosstools-server/wtp/features
## jst
%pom_disable_module org.jboss.tools.jst.test.feature jbosstools-jst/features
## webservices
%pom_disable_module org.jboss.tools.ws.test.feature jbosstools-webservices/features
## javaee
%pom_disable_module jsf jbosstools-javaee
%pom_disable_module seam jbosstools-javaee
%pom_disable_module org.jboss.tools.cdi.test.feature jbosstools-javaee/cdi/features
%pom_disable_module org.jboss.tools.cdi.seam.test.feature jbosstools-javaee/cdi/features
%pom_disable_module org.jboss.tools.cdi.deltaspike.test.feature jbosstools-javaee/cdi/features
## freemarker
%pom_disable_module org.jboss.ide.eclipse.freemarker.test.feature jbosstools-freemarker/features
## openshift
%pom_disable_module org.jboss.tools.openshift.egit.integration.test.feature jbosstools-openshift/features
%pom_disable_module org.jboss.tools.openshift.express.test.feature jbosstools-openshift/features

%patch10
%patch12
%patch14
%patch15
%patch16
%patch17
%patch18
%patch19
%patch21
%patch22
%patch23
%patch24
%patch25

# Add Fedora version to OSGi version qualifier
%pom_xpath_remove pom:project/pom:build/pom:plugins/pom:plugin/pom:configuration/pom:format jbosstools-build/parent
%pom_xpath_inject pom:project/pom:build/pom:plugins/pom:plugin/pom:configuration "<format>'v'yyyyMMdd-HHmm'-\${BUILD_ALIAS}-F%{fedora}'</format>" jbosstools-build/parent

# Set tycho version to 0.18.0-SNAPSHOT in jbosstools-build/parent/pom.xml
sed -i -e 's|<tychoVersion>0.17.0</tychoVersion>|<tychoVersion>0.18.0</tychoVersion>|g' jbosstools-build/parent/pom.xml

# Version hasn't been updated to 4.1.1.Final :-/
%pom_xpath_replace pom:project/pom:version "<version>%{version}.%{rls_tag}</version>" jbosstools-build/parent
%pom_xpath_replace pom:project/pom:version "<version>%{version}.%{rls_tag}</version>" jbosstools-build-sites/aggregate/pom.xml
%pom_set_parent org.jboss.tools:parent:%{version}.%{rls_tag} jbosstools-base/pom.xml
%pom_set_parent org.jboss.tools:parent:%{version}.%{rls_tag} jbosstools-build-sites/aggregate/pom.xml
%pom_set_parent org.jboss.tools:parent:%{version}.%{rls_tag} jbosstools-build-sites/aggregate/local-site/pom.xml
%pom_set_parent org.jboss.tools:parent:%{version}.%{rls_tag} jbosstools-server/pom.xml
%pom_set_parent org.jboss.tools:parent:%{version}.%{rls_tag} jbosstools-javaee/pom.xml
%pom_set_parent org.jboss.tools:parent:%{version}.%{rls_tag} jbosstools-javaee/jsf/pom.xml
%pom_set_parent org.jboss.tools:parent:%{version}.%{rls_tag} jbosstools-javaee/cdi/pom.xml
%pom_set_parent org.jboss.tools:parent:%{version}.%{rls_tag} jbosstools-jst/pom.xml
%pom_set_parent org.jboss.tools:parent:%{version}.%{rls_tag} jbosstools-freemarker/pom.xml
%pom_set_parent org.jboss.tools:parent:%{version}.%{rls_tag} jbosstools-webservices/pom.xml
%pom_set_parent org.jboss.tools:parent:%{version}.%{rls_tag} jbosstools-openshift/pom.xml

%if 0%{?fedora} <= 20
sed -i -e "s/xpp3.jar/xpp3_min.jar/" jbosstools-webservices/plugins/org.jboss.tools.ws.wise.ui/build.properties
%endif

%build
# Build everything from within jbosstools-build-sites
pushd jbosstools-build-sites/aggregate/local-site
  export MAVEN_OPTS="-XX:CompileCommand=exclude,org/eclipse/tycho/core/osgitools/EquinoxResolver,newState ${MAVEN_OPTS}"
  mvn-rpmbuild -f ../../../jbosstools-build/parent/pom.xml install \
               -Dlocal.site=file:.m2/p2/repo
  mvn-rpmbuild install -Dno-target-platform -X -Dmaven.local.debug=true \
               -Dlocal.site=file:.m2/p2/repo
popd


%install
install -d -m 755 %{buildroot}%{_mavenpomdir}

pushd %{build_base}

# POM-only artifacts
for pom in base javaee.all server.all; do
  pushd ${pom}/*-SNAPSHOT/
    install -pm 644 ${pom}-*.pom \
      %{buildroot}%{_mavenpomdir}/JPP-%{name}-${pom}.pom
    %add_maven_depmap JPP-%{name}-${pom}.pom -f ${pom}
  popd
done
pushd parent/%{version}.%{rls_tag}/
  install -pm 644 parent-*.pom \
    %{buildroot}%{_mavenpomdir}/JPP-%{name}-parent.pom
  %add_maven_depmap JPP-%{name}-parent.pom -f parent
popd

# Normal feature/plugin projects
for tool in common usage archives jmx as jst cdi ws freemarker runtime stacks foundation openshift; do
  install -d -m 755 %{buildroot}%{eclipse_dropins}/%{name}-${tool}/eclipse/features
  install -d -m 755 %{buildroot}%{eclipse_dropins}/%{name}-${tool}/eclipse/plugins

  ## POM for each tool
  pushd ${tool}/*-SNAPSHOT
    install -pm 644 ${tool}-*.pom \
      %{buildroot}%{_mavenpomdir}/JPP-%{name}-${tool}.pom
    %add_maven_depmap JPP-%{name}-${tool}.pom -f ${tool}
    popd

  ## features
  pushd ${tool}/features
    for feat in `echo *.feature`; do
      pushd ${feat}/*-SNAPSHOT
        unzip ${feat}-*-SNAPSHOT.jar -d \
         %{buildroot}%{eclipse_dropins}/%{name}-${tool}/eclipse/features/${feat}
      popd;
    done;
  popd

  ##plugins
  pushd ${tool}/plugins
    for plug in `find -name *.jar | grep -v -e "sources.jar" \
                    -e "org.jboss.tools.ws.ui-" \
                    -e "org.jboss.ide.eclipse.as.dmr-" \
                    -e "org.jboss.ide.eclipse.as.core-" \
                    -e "org.jboss.ide.eclipse.freemarker-" \
                    -e "org.jboss.ide.eclipse.archives.core-" \
                    -e "org.jboss.tools.openshift.express.client-" \
                    -e "org.jboss.ide.eclipse.as.management.as71-" `; \
    do
      install -p ${plug} %{buildroot}%{eclipse_dropins}/%{name}-${tool}/eclipse/plugins
    done;
  popd;

done;

  # org.jboss.tools.ws.ui
  pushd ws/plugins/org.jboss.tools.ws.ui/
    bundleversion=`ls | grep SNAPSHOT`
    pushd ${bundleversion}
      unjar=`ls *-${bundleversion}.jar | sed -e 's/.jar//'`
      unzip -q -d %{buildroot}%{eclipse_dropins}/%{name}-ws/eclipse/plugins/${unjar} ${unjar}.jar
    popd
  popd
  pushd %{buildroot}%{eclipse_dropins}/%{name}-ws/eclipse/plugins/${unjar}/lib/
    rm -f *.jar
    ln -s %{_javadir}/axis/axis.jar
    ln -s %{_javadir}/axis/jaxrpc.jar
    ln -s %{_javadir}/resteasy/jaxrs-api.jar
  popd

  # org.jboss.tools.ws.wise.ui
  pushd ws/org.jboss.tools.ws.wise.ui/
    bundleversion=`ls | grep SNAPSHOT`
    pushd ${bundleversion}
      unjar=`ls *-${bundleversion}.jar | sed -e 's/.jar//'`
      unzip -q -d %{buildroot}%{eclipse_dropins}/%{name}-ws/eclipse/plugins/${unjar} ${unjar}.jar
    popd
  popd
  pushd %{buildroot}%{eclipse_dropins}/%{name}-ws/eclipse/plugins/${unjar}/lib/
    rm -f *.jar
    ln -s %{_javadir}/ant.jar
    ln -s %{_javadir}/ant-launcher.jar
    ln -s %{_javadir}/objectweb-asm/asm.jar
    ln -s %{_javadir}/objectweb-asm/asm-tree.jar
    ln -s %{_javadir}/objectweb-asm/asm-util.jar
    ln -s %{_javadir}/avalon-framework-api.jar
    ln -s %{_javadir}/avalon-logkit.jar
    ln -s %{_javadir}/batik/batik-ext.jar
    ln -s %{_javadir}/codemodel.jar
    ln -s %{_javadir}/commons-codec.jar
    ln -s %{_javadir}/commons-collections.jar
    ln -s %{_javadir}/commons-httpclient.jar
    ln -s %{_javadir}/commons-io.jar
    ln -s %{_javadir}/commons-lang.jar
    ln -s %{_javadir}/commons-logging.jar
    ln -s %{_javadir}/cxf/api.jar cxf-api.jar
    ln -s %{_javadir}/cxf/rt-bindings-coloc.jar cxf-rt-bindings-coloc.jar
    ln -s %{_javadir}/cxf/rt-bindings-object.jar cxf-rt-bindings-object.jar
    ln -s %{_javadir}/cxf/rt-bindings-soap.jar cxf-rt-bindings-soap.jar
    ln -s %{_javadir}/cxf/rt-bindings-xml.jar cxf-rt-bindings-xml.jar
    ln -s %{_javadir}/cxf/rt-core.jar cxf-rt-core.jar
    ln -s %{_javadir}/cxf-rt-databinding-jaxb.jar cxf-rt-databinding-jaxb.jar
    ln -s %{_javadir}/cxf/rt-frontend-jaxws.jar cxf-rt-frontend-jaxws.jar
    ln -s %{_javadir}/cxf/rt-frontend-simple.jar cxf-rt-frontend-simple.jar
    ln -s %{_javadir}/cxf/rt-transports-http.jar cxf-rt-transports-http.jar
    ln -s %{_javadir}/cxf/rt-transports-local.jar cxf-rt-transports-local.jar
    ln -s %{_javadir}/cxf/rt-ws-addr.jar cxf-rt-ws-addr.jar
    ln -s %{_javadir}/cxf/rt-ws-mex.jar cxf-rt-ws-mex.jar
    ln -s %{_javadir}/cxf/rt-ws-policy.jar cxf-rt-ws-policy.jar
    ln -s %{_javadir}/cxf/cxf-services-ws-discovery-api.jar
    ln -s %{_javadir}/cxf/cxf-tools-common.jar
    ln -s %{_javadir}/cxf/cxf-tools-validator.jar
    ln -s %{_javadir}/cxf/cxf-tools-wsdlto-core.jar
    ln -s %{_javadir}/cxf/cxf-tools-wsdlto-databinding-jaxb.jar
    ln -s %{_javadir}/cxf/cxf-tools-wsdlto-frontend-jaxws.jar
    ln -s %{_javadir}/cxf-xjc-utils/cxf-xjc-boolean.jar
    ln -s %{_javadir}/cxf-xjc-utils/cxf-xjc-dv.jar
    ln -s %{_javadir}/cxf-xjc-utils/cxf-xjc-ts.jar
    ln -s %{_javadir}/dtdparser.jar
    ln -s %{_javadir}/freemarker.jar
    ln -s %{_javadir}/hsqldb.jar
    ln -s %{_javadir}/istack-commons-runtime.jar
    ln -s %{_javadir}/istack-commons-tools.jar
    ln -s %{_javadir}/gnu-getopt.jar java-getopt.jar
    ln -s %{_javadir}/javassist.jar
    ln -s %{_javadir}/glassfish-jaxb/jaxb-impl.jar
    ln -s %{_javadir}/glassfish-jaxb/jaxb-xjc.jar
    ln -s %{_javadir}/jaxen.jar
    ln -s %{_javadir}/jboss-jaxb-2.2-api.jar jboss-jaxb-api_2.2_spec.jar
    ln -s %{_javadir}/jboss-jaxrpc-1.1-api.jar jboss-jaxrpc-api_1.1_spec.jar
    ln -s %{_javadir}/jboss-jaxws-2.2-api.jar jboss-jaxws-api_2.2_spec.jar
    ln -s %{_javadir}/jboss-logging/jboss-logging.jar
    ln -s %{_javadir}/jboss-saaj-1.3-api.jar jboss-saaj-api_1.3_spec.jar
    ln -s %{_javadir}/jboss-servlet-3.0-api/jboss-servlet-api_3.0_spec.jar
    ln -s %{_javadir}/jbossws-api/jbossws-api.jar
    ln -s %{_javadir}/jbossws-common/jbossws-common.jar
    ln -s %{_javadir}/jbossws-common-tools/jbossws-common-tools.jar
    ln -s %{_javadir}/jbossws-cxf/jbossws-cxf-client.jar
    ln -s %{_javadir}/jbossws-cxf/jbossws-cxf-factories.jar
    ln -s %{_javadir}/jbossws-cxf/jbossws-cxf-transports-udp.jar
    ln -s %{_javadir}/jbossws-spi/jbossws-spi.jar
    ln -s %{_javadir}/jms.jar
    ln -s %{_javadir}/jta.jar
    ln -s %{_javadir}/log4j.jar
    ln -s %{_javadir}/javamail/mail.jar
    ln -s %{_javadir}/smooks/milyn-commons.jar
    ln -s %{_javadir}/smooks/milyn-smooks-core.jar
    ln -s %{_javadir}/smooks/milyn-smooks-javabean.jar
    ln -s %{_javadir}/smooks/milyn-smooks-rules.jar
    ln -s %{_javadir}/smooks/milyn-smooks-validation.jar
    ln -s %{_javadir}/mvel.jar
    ln -s %{_javadir}/neethi.jar
    ln -s %{_javadir}/opencsv.jar
    ln -s %{_javadir}/rngom.jar
    ln -s %{_javadir}/servlet.jar servlet-api.jar
    ln -s %{_javadir}/stax2-api.jar stax-api.jar
    ln -s %{_javadir}/txw2.jar
    ln -s %{_javadir}/velocity.jar
    ln -s %{_javadir}/wise/wise-core-cxf.jar
    ln -s %{_javadir}/wise/wise-core.jar
    ln -s %{_javadir}/usr/share/java/xml-commons-apis.jar xml-apis.jar
    ln -s %{_javadir}/ws-xmlschema/xmlschema-core.jar
    ln -s %{_javadir}/xpp3-minimal.jar xpp3.jar
    ln -s %{_javadir}/xsom.jar
    ln -s %{_javadir}/xstream.jar
  popd

  # org.jboss.ide.eclipse.as.dmr
  pushd as/plugins/org.jboss.ide.eclipse.as.dmr/
    bundleversion=`ls | grep SNAPSHOT`
    pushd ${bundleversion}
      unjar=`ls *-${bundleversion}.jar | sed -e 's/.jar//'`
      unzip -q -d %{buildroot}%{eclipse_dropins}/%{name}-as/eclipse/plugins/${unjar} ${unjar}.jar
    popd
  popd
  pushd %{buildroot}%{eclipse_dropins}/%{name}-as/eclipse/plugins/${unjar}/
    rm -f *.jar
    ln -s %{_javadir}/jboss-dmr/jboss-dmr.jar
  popd

  # org.jboss.ide.eclipse.as.core
  pushd as/plugins/org.jboss.ide.eclipse.as.core
    bundleversion=`ls | grep SNAPSHOT`
    pushd ${bundleversion}
      unjar=`ls *-${bundleversion}.jar | sed -e 's/.jar//'`
      unzip -q -d %{buildroot}%{eclipse_dropins}/%{name}-as/eclipse/plugins/${unjar} ${unjar}.jar
    popd
  popd
  pushd %{buildroot}%{eclipse_dropins}/%{name}-as/eclipse/plugins/${unjar}/
    rm -f *.jar
    ln -s %{_javadir}/dom4j.jar
    ln -s %{_javadir}/jaxen.jar
    ln -s %{_javadir}/gnu-getopt.jar
  popd

  # org.jboss.ide.eclipse.as.management.as71
  pushd as/plugins/org.jboss.ide.eclipse.as.management.as71
    bundleversion=`ls | grep SNAPSHOT`
    pushd ${bundleversion}
      unjar=`ls *-${bundleversion}.jar | sed -e 's/.jar//'`
      unzip -q -d %{buildroot}%{eclipse_dropins}/%{name}-as/eclipse/plugins/${unjar} ${unjar}.jar
    popd
  popd
  pushd %{buildroot}%{eclipse_dropins}/%{name}-as/eclipse/plugins/${unjar}/
    rm -f *.jar
    ln -s %{_javadir}/wildfly/wildfly-controller-client.jar
    ln -s %{_javadir}/wildfly/wildfly-protocol.jar
    ln -s %{_javadir}/jboss-dmr/jboss-dmr.jar
    ln -s %{_javadir}/jboss-logging/jboss-logging.jar
    ln -s %{_javadir}/jboss-marshalling.jar
    ln -s %{_javadir}/jboss-marshalling-river.jar
    ln -s %{_javadir}/jboss-remoting/jboss-remoting.jar
    ln -s %{_javadir}/jboss-sasl.jar
    ln -s %{_javadir}/jboss-threads/jboss-threads.jar
    ln -s %{_javadir}/xnio/xnio-api.jar
    ln -s %{_javadir}/xnio/xnio-nio.jar
  popd

  # org.jboss.ide.eclipse.freemarker
  pushd freemarker/plugins/org.jboss.ide.eclipse.freemarker/
    bundleversion=`ls | grep SNAPSHOT`
    pushd ${bundleversion}
      unjar=`ls *-${bundleversion}.jar | sed -e 's/.jar//'`
      unzip -q -d %{buildroot}%{eclipse_dropins}/%{name}-freemarker/eclipse/plugins/${unjar} ${unjar}.jar
    popd
  popd
  pushd %{buildroot}%{eclipse_dropins}/%{name}-freemarker/eclipse/plugins/${unjar}/
    rm -f freemarker.jar
    ln -s %{_javadir}/freemarker.jar
  popd

  # org.jboss.ide.eclipse.archives.core
  pushd archives/plugins/org.jboss.ide.eclipse.archives.core
    bundleversion=`ls | grep SNAPSHOT`
    pushd ${bundleversion}
      unjar=`ls *-${bundleversion}.jar | sed -e 's/.jar//'`
      unzip -q -d %{buildroot}%{eclipse_dropins}/%{name}-archives/eclipse/plugins/${unjar} ${unjar}.jar
    popd
  popd
  pushd %{buildroot}%{eclipse_dropins}/%{name}-archives/eclipse/plugins/${unjar}/lib
    rm -f *.jar
    ln -s %{_javadir}/truezip/truezip-driver-file.jar
    ln -s %{_javadir}/truezip/truezip-driver-zip.jar
    ln -s %{_javadir}/truezip/truezip-file.jar
    ln -s %{_javadir}/truezip/truezip-kernel.jar
  popd

  # org.jboss.tools.openshift.express.client
  pushd openshift/plugins/org.jboss.tools.openshift.express.client
    bundleversion=`ls | grep SNAPSHOT`
    pushd ${bundleversion}
      unjar=`ls *-${bundleversion}.jar | sed -e 's/.jar//'`
      unzip -q -d %{buildroot}%{eclipse_dropins}/%{name}-openshift/eclipse/plugins/${unjar} ${unjar}.jar
    popd
  popd
  pushd %{buildroot}%{eclipse_dropins}/%{name}-openshift/eclipse/plugins/${unjar}/lib
    rm -f *.jar
    ln -s %{_javadir}/jboss-dmr/jboss-dmr.jar
    ln -s %{_javadir}/log4j.jar
    ln -s %{_javadir}/openshift-java-client/openshift-java-client.jar
    ln -s %{_javadir}/slf4j/api.jar slf4j-api.jar
    ln -s %{_javadir}/slf4j/log4j12.jar slf4j-log4j12.jar
  popd

  # org.jboss.tools.jst.web.kb is in jbosstools-jst/tests, but we need it
  install -p jst/tests/org.jboss.tools.jst.web.kb/*-SNAPSHOT/*-SNAPSHOT.jar \
    %{buildroot}%{eclipse_dropins}/%{name}-jst/eclipse/plugins

popd;

%files

%files parent
%{_mavenpomdir}/JPP-%{name}-parent.pom
%{_mavendepmapfragdir}/%{name}-parent
 
%files common
%doc lgpl-2.1.txt
%doc jbosstools-base/tests/features/org.jboss.tools.test.feature/epl-v10.html
%{eclipse_dropins}/%{name}-common
%{_mavenpomdir}/JPP-%{name}-common.pom
%{_mavendepmapfragdir}/%{name}-common

%files usage
%doc LICENSE-2.0.txt
%doc jbosstools-base/tests/features/org.jboss.tools.test.feature/epl-v10.html
%{eclipse_dropins}/%{name}-usage
%{_mavenpomdir}/JPP-%{name}-usage.pom
%{_mavendepmapfragdir}/%{name}-usage

%files archives
%doc lgpl-2.1.txt
%{eclipse_dropins}/%{name}-archives
%{_mavenpomdir}/JPP-%{name}-archives.pom
%{_mavendepmapfragdir}/%{name}-archives

%files jmx
%doc jbosstools-base/tests/features/org.jboss.tools.test.feature/epl-v10.html
%{eclipse_dropins}/%{name}-jmx
%{_mavenpomdir}/JPP-%{name}-jmx.pom
%{_mavendepmapfragdir}/%{name}-jmx

%files as
%{eclipse_dropins}/%{name}-as
%{_mavenpomdir}/JPP-%{name}-as.pom
%{_mavendepmapfragdir}/%{name}-as

%files jst
%{eclipse_dropins}/%{name}-jst
%{_mavenpomdir}/JPP-%{name}-jst.pom
%{_mavendepmapfragdir}/%{name}-jst

%files cdi
%{eclipse_dropins}/%{name}-cdi
%{_mavenpomdir}/JPP-%{name}-cdi.pom
%{_mavendepmapfragdir}/%{name}-cdi

%files ws
%doc lgpl-2.1.txt
%{eclipse_dropins}/%{name}-ws
%{_mavenpomdir}/JPP-%{name}-ws.pom
%{_mavendepmapfragdir}/%{name}-ws

%files freemarker
%doc lgpl-2.1.txt
%{eclipse_dropins}/%{name}-freemarker
%{_mavenpomdir}/JPP-%{name}-freemarker.pom
%{_mavendepmapfragdir}/%{name}-freemarker

%files runtime
%{eclipse_dropins}/%{name}-runtime
%{_mavenpomdir}/JPP-%{name}-runtime.pom
%{_mavendepmapfragdir}/%{name}-runtime

%files base
%{_mavenpomdir}/JPP-%{name}-base.pom
%{_mavendepmapfragdir}/%{name}-base

%files foundation
%{eclipse_dropins}/%{name}-foundation
%{_mavenpomdir}/JPP-%{name}-foundation.pom
%{_mavendepmapfragdir}/%{name}-foundation

%files stacks
%{eclipse_dropins}/%{name}-stacks
%{_mavenpomdir}/JPP-%{name}-stacks.pom
%{_mavendepmapfragdir}/%{name}-stacks

%files javaee
%{_mavenpomdir}/JPP-%{name}-javaee.all.pom
%{_mavendepmapfragdir}/%{name}-javaee.all

%files server
%{_mavenpomdir}/JPP-%{name}-server.all.pom
%{_mavendepmapfragdir}/%{name}-server.all

%files openshift
%{eclipse_dropins}/%{name}-openshift
%{_mavenpomdir}/JPP-%{name}-openshift.pom
%{_mavendepmapfragdir}/%{name}-openshift

%changelog
* Fri Dec 20 2013 Gerard Ryan <galileo@fedoraproject.org> - 4.1.1-2
- Update to 4.1.1.Final

* Wed Oct 02 2013 Gerard Ryan <galileo@fedoraproject.org> - 4.1.0-7
- RHBZ-1014459: Unbundle jars from plugin bundles

* Tue Oct 01 2013 Gerard Ryan <galileo@fedoraproject.org> - 4.1.0-6
- Re-add jbosstools-openshift subpackage

* Mon Sep 16 2013 Gerard Ryan <galileo@fedoraproject.org> - 4.1.0-5
- RHBZ-1008307: Workaround for problem in arm which causes NPE

* Fri Sep 13 2013 Gerard Ryan <galileo@fedoraproject.org> - 4.1.0-4
- Bump release to rebuild for f20
- Disable jacoco plugin in parent pom

* Sat Sep 07 2013 Gerard Ryan <galileo@fedoraproject.org> - 4.1.0-3
- Update to use wildfly and updated jar locations

* Sun Aug 18 2013 Gerard Ryan <galileo@fedoraproject.org> - 4.1.0-2
- Add org.jboss.tools.ws.wise.ui to ws package

* Sun Aug 18 2013 Gerard Ryan <galileo@fedoraproject.org> - 4.1.0-1
- Update to latest upstream version 4.1.0 on f19+

* Sat Aug 03 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 4.0.0-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Wed Feb 13 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 4.0.0-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild

* Wed Feb 06 2013 Java SIG <java-devel@lists.fedoraproject.org> - 4.0.0-2
- Update for https://fedoraproject.org/wiki/Fedora_19_Maven_Rebuild
- Replace maven BuildRequires with maven-local

* Tue Oct 16 2012 Gerard Ryan <galileo@fedoraproject.org> - 4.0.0-1
- Update to upstream 4.0.0.Final
- Add script create-tarball.sh to create source tarball from Git.
- Update locations for symlinked jars and POM macros.
- Remove unnecessary pom macros.

* Tue Oct 16 2012 Gerard Ryan <galileo@fedoraproject.org> - 4.0.0-0.2
- Update to tag jbosstools-4.0.0.Alpha2.
- Add subpackage runtime, necessary for 'as' subpackage.
- Shorten summary line.
- Rebase patches 14, 15, 16, 21, 23; append -4.0.0 to patch name.
- Remove patches 13, 20.
- Remove dependency on jbossxb.

* Mon Oct 08 2012 Gerard Ryan <galileo@fedoraproject.org> - 3.3.1-5
- Build as a noarch package.

* Tue Sep 04 2012 Gerard Ryan <galileo@fedoraproject.org> - 3.3.1-4
- Add Fedora version to OSGi version qualifier.

* Sat Aug 11 2012 Gerard Ryan <galileo@fedoraproject.org> - 3.3.1-3
- Make build process more efficient & remove -Dmaven.test.skip option.
- Use pom macros, and remove patches that are no longer necessary.
- Add tests module to tarball.
- Add apache-commons-codec as BR.

* Thu Jul 26 2012 Gerard Ryan <galileo@fedoraproject.org> - 3.3.1-2
- Fix license field and install license files.
- Use a clean tarball to reduce srpm size.
- Use spaces consistently; add some necessary comments.

* Thu Jul 26 2012 Gerard Ryan <galileo@fedoraproject.org> - 3.3.1-1
- Initial packaging.
